// Вывод данных осуществляется на LCD 1602 I2C дисплей                        http://iarduino.ru/shop/Displei/simvolnyy-displey-golubaya-podsvetka-lcd1602-iic-i2c.html
// Инициализация чтение и проход по адресам осуществляется нажатием на кнопку http://iarduino.ru/shop/Expansion-payments/knopka-trema-modul.html
// Подключение исследуемых модулей удобно осуществлять через Trema I2C Hub    http://iarduino.ru/shop/Expansion-payments/i2c-hub-trema-modul.html

// Подключаем библиотеки:
#include <Wire.h>                                                             // подключаем библиотеку для работы с шиной I2C (для работы с дисплеем)
#include <LiquidCrystal_I2C.h>                                                // подключаем библиотеку для работы с LCD дисплеем
// Объявляем переменные и константы:
LiquidCrystal_I2C lcd(0x27,16,2);                                             // объявляем  переменную для работы с LCD дисплеем, указывая параметры дисплея (адрес I2C = 0x27, количество столбцов = 16, количество строк = 2)
const uint8_t     PIN_button_SET = 2;                                         // указываем  номер вывода arduino, к которому подключена кнопка SET
      uint8_t     SEC_button_SET;                                             // переменная содержащая десятые доли секунд времени удержания кнопки SET
      uint8_t     NUM_found_ADDR;                                             // количество найденных адресов
      uint8_t     MAS_found_ADDR[127];                                        // массив     найденных адресов
      uint8_t     OUT_found_ADDR = 1;                                         // выводимый  адрес из списка найденных
void setup(){
  pinMode(PIN_button_SET, INPUT);                                             // конфигурируем вывод кнопки, как вход
  lcd.init();                                                                 // инициируем LCD дисплей
  lcd.backlight();                                                            // включаем подсветку LCD дисплея
  lcd.clear(); lcd.setCursor(0, 0); lcd.print(F("iArduino.ru"));              // выводим текст "iArduino.ru"
  delay(2000);                                                                // ждём 2 секунды
  lcd.clear(); lcd.setCursor(0, 0); lcd.print(F("Please click..."));          // чистим экран
}
void loop(){
  if(digitalRead(PIN_button_SET)){                                            //  Если нажата кнопка, то ...
    lcd.clear();                                                              //  Стираем экран
    SEC_button_SET=0;                                                         //  Обнуляем счётчик удержания кнопки
    while(digitalRead(PIN_button_SET)){                                       //  Создаём цикл, пока кнопка не будет отпушена
      delay(10);                                                              //  Пропускаем 10мс
      if(SEC_button_SET<100){SEC_button_SET++;}                               //  Если прошло меньше 1 секунды, инкрементируем счетчик удержания кнопки
      else{lcd.setCursor(0, 0); lcd.print(F("Start Search..."));}             //  Выводим на экран текст "Start Search..."
    }                                                                         //  Как только кнопка отпущена, выполняем одно из двух действий ...
    if(SEC_button_SET<100){                                                   //  Если кнопка SET удерживалась меньше 1 секунды, то показываем значение очередного адреса ...
      OUT_found_ADDR++; if(OUT_found_ADDR>NUM_found_ADDR){OUT_found_ADDR=1;}  //  Инкрементируем номер выводимого адреса
    }else{                                                                    //  Если кнопка SET удерживалась дольше 1 секунды, то читаем адреса устройств на шине I2C...
      NUM_found_ADDR=0;                                                       //  Сбрасываем количество найденных адресов
      OUT_found_ADDR=1;                                                       //  Сбрасываем номер выводимого адреса
      for(uint8_t i=1; i<127; i++){                                           //  Проходим по всем доступным адресам (от 1 до 126)
      if(func_START()){                                                       //  Устанавливаем состояние СТАРТ
      if(func_SEND(i)){                                                       //  Отправляем байт адреса с битом RW=0 (операция записи)
      if(i!=0x27){                                                            //  Если найден адрес 0x27, то пропускаем его, т.к. это адрес LCD дисплея
        MAS_found_ADDR[NUM_found_ADDR]=i; NUM_found_ADDR++;                   //  Добавляем адрес в массив
      }}} func_STOP();}                                                       //  Устанавливаем состояние СТОП
    }                                                                         //  Выводим данные на LCD дисплей
    lcd.clear();       lcd.setCursor(0, 0); lcd.print(F("ALL"));       lcd.setCursor(4, 0); lcd.print(F("ADDR = "  )); lcd.print(NUM_found_ADDR);
    if(NUM_found_ADDR){lcd.setCursor(0, 1); lcd.print(OUT_found_ADDR); lcd.setCursor(4, 1); lcd.print(F("ADDR = 0x")); lcd.print(MAS_found_ADDR[(OUT_found_ADDR-1)],HEX);}
  }
}
bool func_START()         {uint16_t i=0;              TWCR = _BV(TWINT) | _BV(TWEN) | _BV(TWSTA); while(!(TWCR & _BV(TWINT))){i++; if(i>=60000){return false;}} if((TWSR & 0xF8)!=0x08){return false;} return true;}
bool func_SEND (uint8_t j){uint16_t i=0; TWDR = j<<1; TWCR = _BV(TWINT) | _BV(TWEN);              while(!(TWCR & _BV(TWINT))){i++; if(i>=60000){return false;}} if((TWSR & 0xF8)!=0x18){return false;} return true;}
void func_STOP ()         {uint16_t i=0;              TWCR = _BV(TWINT) | _BV(TWEN) | _BV(TWSTO); while(!(TWCR & _BV(TWSTO))){i++; if(i>=60000){break;       }} delayMicroseconds(20);                             }
